﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.IO;
using System;

public class BotonNewGame : MonoBehaviour {
	// Funcionalidad del boton NewGame. Graba en el registro del fichero Status para inicializar contadores.

	List<PersonalData> personaldata = new List<PersonalData>();
	public string nombre = "";
	public int monedas= 0 ;
	string currentTime=System.DateTime.Now.ToString();
	public int nivel = 1;
	private Animator animator;
	public bool apretado = true;
	public bool hayerror = false;
	public string msgerror = "";

	void Awake(){
		animator = GetComponent<Animator>();
	}

	// Se graba la informacion del estado de la partida en Status.gd
	void OnMouseDown(){
		
		personaldata.Add (new PersonalData(nivel,monedas));

		Salvar ();
		CargarNiveles.generalNivel = nivel;
		CargarNiveles.generalRecord = monedas;
		CargarNiveles.generalNombre = nombre;
		CargarNiveles.generalFecha = currentTime;
		Camera.main.audio.Stop ();
		animator.SetBool ("apretado", true);
		audio.Play ();
		Invoke ("CargarEscena", audio.clip.length);

		
		
		
	}
	void CargarEscena(){
		Application.LoadLevel("Escena1");
	}
	void Salvar(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Create (Application.persistentDataPath + "/Status.gd");
			bf.Serialize(file, personaldata);
			file.Close();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to write files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
		
	}
	void OnGUI() {
		if (hayerror) {
			GUI.Label (new Rect (0, 0, Screen.width, Screen.height),"Error. Aplication going be closed." + msgerror );
			Invoke("CerrarApp",4f);
		}
	}
	void CerrarApp(){
		Application.Quit ();
	}
}
