﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.IO;
using System;

public class BotonOptionsPrincipal : MonoBehaviour {
	//Funcionalidad del boton Options del menu Principal. Abre el fichero Settings donde se guarda informacion
	// del volumen de la musica y efectos especiales y da paso a la pantalla de configuracion del volumen
	private Animator animator;
	public bool apretado = true;
	List<OptionsData> optionsdata = new List<OptionsData>();
	public string ficheroSetting ="/Setting.gs";
	public bool hayerror = false;
	public string msgerror = "";

	void Awake(){
		animator = GetComponent<Animator>();
	}

	// Use this for initialization
	void OnMouseDown(){
		Camera.main.audio.Stop ();
		animator.SetBool ("apretado", true);
		audio.Play ();
		Invoke ("CargarOptions", audio.clip.length);

		
	}
	void CargarOptions(){
		Application.LoadLevel("Options");
	}
	void CargarSettings(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroSetting,FileMode.Open);
			optionsdata = (List<OptionsData>)bf.Deserialize(file);
			CargarNiveles.generalVolumenFx = optionsdata [0].volumeFx;
			CargarNiveles.generalVolumenMusic = optionsdata [0].volumeMusic;
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void OnGUI() {
		if (hayerror) {
			GUI.Label (new Rect (0, 0, Screen.width, Screen.height),"Error. Aplication going be closed." + msgerror );
			Invoke("CerrarApp",4f);
		}
	}
	void CerrarApp(){
		Application.Quit ();
	}
}
