﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.IO;
using System;

public class BotonReturnOptions : MonoBehaviour {
	// Funcionalidad del Boton Return de la pantalla de Opciones. Graba la informacion del volumen de 
	// efectos especiales y musica en el fichero Setting.
	List<OptionsData> optionsdata = new List<OptionsData>();
	private Animator animator;
	public string fichero = "/Setting.gd";
	public bool hayerror = false;
	public string msgerror = "";

	void Awake(){
		animator = GetComponent<Animator>();
	}
	void OnMouseDown(){
		
		optionsdata.Add (new OptionsData(CargarNiveles.generalVolumenFx,CargarNiveles.generalVolumenMusic));
		Salvar ();
		Camera.main.audio.Stop ();
		animator.SetBool ("apretado", true);
		audio.Play ();
		Invoke ("CargarEscena", audio.clip.length);
		
		
		
		
	}
	void CargarEscena(){
		Application.LoadLevel("Portada");
	}


	void Salvar(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Create (Application.persistentDataPath + fichero);
			bf.Serialize(file, optionsdata);
			file.Close();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
		
	}
	void OnGUI() {
		if (hayerror) {
			GUI.Label (new Rect (0, 0, Screen.width, Screen.height),"Error. Aplication going be closed." + msgerror );
			Invoke("CerrarApp",4f);
		}
	}
	void CerrarApp(){
		Application.Quit ();
	}
}
