﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.IO;
using System;

public class CargarNiveles : MonoBehaviour {
	//Esta clase controla todo lo relativo a los niveles. Recoge informacion de los ficheros de niveles y construye el
	// nivel en la escena Escena1.
	public GameObject[] obj;
	public Vector3 aPosition = new Vector3(1, 1, 1);
	public string ficheroFijoGoals = "/Goals";
	public string ficheroRecord = "/Record.gd";
	public string ficheroStatus = "/Status.gd";
	public string ficheroFijoNivel ="/Nivel";
	public string ficheroSetting ="/Setting.gs";
	public string ficheroNivel = "";
	public string ficheroGoals = "";

	// Se declaran static para poder acceder desde cualquier script
	public static int generalMinutos;
	public static int generalSegundos;
	public static int[] generalObjetos;
	public static int[] generalCantidad;
	public static float generalVolumenFx = 0.5f;
	public static float generalVolumenMusic = 0.5f;
	public static int generalNivel= 0 ;
	public static int generalRecord= 0;
	public static string generalNombre = "";
	public static string generalFecha= "";
	public static int generalPuntuacion = 0;
	public static int generalMaxNivel = 0;
	public TextMesh textoMinutos;
	public TextMesh textoSegundos;
	public float tiempo;
	public int minutos;
	public int segundos;
	public bool empezarContar = false;


	List<Game> game = new List<Game>(); // datos objetos nivel
	List<NivelData> niveldata = new List<NivelData>(); // datos objetivo nivel
	List<RecordData> recorddata = new List<RecordData>(); // datos record personal y nivel por donde va el jugador
	List<PersonalData> personaldata = new List<PersonalData>();
	List<OptionsData> optionsdata = new List<OptionsData>();
	// manejo de excepciones
	public bool hayerror = false;
	public string msgerror = "";

	// Use this for initialization
	void Start () {

		NotificationCenter.DefaultCenter ().AddObserver (this, "EmpiezaContarTiempo");
		CargarStatus ();
		CargarRecord ();
		CargarGoals ();
		CargarObjetos ();
		Generar ();
		// Se calcula el tiempo total en segundos
		tiempo = (CargarNiveles.generalMinutos * 60) + CargarNiveles.generalSegundos;



	}
	void Awake(){
	//	startTime = Time.deltaTime;
	}
	void EmpiezaContarTiempo(Notification empieza){
		empezarContar = (bool)empieza.data;

	}
	void FixedUpdate(){
		Segundos ();
	}
	// Update is called once per frame
	void Update () {

	
	}
	void Segundos(){
		if (empezarContar == true) {
			tiempo = tiempo - Time.fixedDeltaTime;
			
			minutos = (int)tiempo / 60;
			segundos = (int)tiempo % 60;
			if (minutos >= 0 && minutos <= 9){
				textoMinutos.text = "0"+ minutos.ToString ();
			}else{
				textoMinutos.text = minutos.ToString ();
			}
			if (segundos >=0 && segundos <= 9){
				textoSegundos.text = "0" + segundos.ToString ();
			}else{
				textoSegundos.text = segundos.ToString ();
			}
			if (minutos <= 0 && segundos <= 0 ) {
				NotificationCenter.DefaultCenter ().PostNotification (this, "FinalJuego",true);
			}
		}

	}
	void Generar() {
		for (int i = 0; i < game.Count - 1; i++)
		{
			aPosition.x = game[i].posX;
			aPosition.y = game[i].posY;
			aPosition.z = game[i].posZ;

			GameObject objName = (GameObject)Instantiate(obj[game[i].obj],aPosition,Quaternion.identity);

			objName.name = obj[game[i].obj].name;
		

		}
	}
	void CargarRecord(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroRecord,FileMode.Open);
			recorddata = (List<RecordData>)bf.Deserialize(file);
			generalRecord = recorddata [0].record;
			generalNombre = recorddata [0].nombre;
			generalFecha = recorddata [0].fecha;
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void CargarStatus(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroStatus,FileMode.Open);
			personaldata = (List<PersonalData>)bf.Deserialize(file);
			generalNivel = personaldata [0].nivel;
			generalPuntuacion = personaldata [0].monedas;
			ficheroGoals = ficheroFijoGoals + generalNivel + ".gd";
			ficheroNivel = ficheroFijoNivel + generalNivel + ".gd";
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void CargarObjetos(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroNivel,FileMode.Open);
			game = (List<Game>)bf.Deserialize(file);
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void CargarSettings(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroSetting,FileMode.Open);
			optionsdata = (List<OptionsData>)bf.Deserialize(file);
			generalVolumenFx = optionsdata [0].volumeFx;
			generalVolumenMusic = optionsdata [0].volumeMusic;
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void CargarGoals(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Open (Application.persistentDataPath + ficheroGoals,FileMode.Open);
			niveldata = (List<NivelData>)bf.Deserialize(file);
			generalMinutos = niveldata [0].minutos;
			generalSegundos = niveldata [0].segundos;
			generalObjetos = niveldata [0].obj;
			generalCantidad = niveldata [0].cantidad;
			if (CargarNiveles.generalMinutos >= 0 && CargarNiveles.generalMinutos <= 9) {
				textoMinutos.text = "0" + generalMinutos.ToString();
			} else { 
				textoMinutos.text = generalMinutos.ToString(); 
			}
			textoSegundos.text = generalSegundos.ToString();
			file.Close ();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
	}
	void OnGUI() {
		if (hayerror) {
			GUI.Label (new Rect (0, 0, Screen.width, Screen.height),"Error. Aplication going be closed." + msgerror );
			Invoke("CerrarApp",4f);
		}
	}
	void CerrarApp(){
		Application.Quit ();
	}
}
