﻿using UnityEngine;
using System.Collections;

public class ControlJim : MonoBehaviour {
	// Clase que controla los movimientos del personaje. Comprueba si esta tocando el suelo, si esta saltando,
	// o si esta rodando.
	public float impulsoSalto = 220f;
	private int mitadPantalla = 0;
// Las siguientes variables nos van a servir para saber si el pie derecho toca el suelo
	public bool estaEnSuelo = true;
	public Transform pieEnSuelo;
	float comprobadorArea = 0.13f;

	public bool empezado = false;
	public bool estaVolteando = false;

	public bool pergamino = false;
	 
// Recordar poner los objetos que pertenezcan al suelo con mascara "SUELO"
	public LayerMask mascaraSuelo;
	public bool saltarOtraVez = true;

// variables para el animador
	private Animator animator;

// variables para que el personaje corra
	public bool corriendo = false;
	public float velocidad = 1.0f;

	private GameObject jim;



	void Start () {
		// calculamos la mitad de la pantalla 
		mitadPantalla = Screen.width / 2;
		NotificationCenter.DefaultCenter ().AddObserver (this, "EmpiezaElJuego");

	}
	void EmpiezaElJuego(Notification pergaminoOculto){
		pergamino =(bool) pergaminoOculto.data;
		NotificationCenter.DefaultCenter ().PostNotification (this, "EmpiezaContarTiempo",true);
	}
	// Funcion para usar el animador
	void Awake(){
		animator = GetComponent<Animator>();
	}



	
	void FixedUpdate() {

		if (corriendo) { 
			rigidbody2D.velocity = new Vector2(velocidad, rigidbody2D.velocity.y);

		
		}
		estaEnSuelo = Physics2D.OverlapCircle (pieEnSuelo.position, comprobadorArea, mascaraSuelo);
		animator.SetBool ("enSuelo", estaEnSuelo);
		if (estaEnSuelo) {
			saltarOtraVez = false;
			if (estaVolteando){
				
				animator.SetBool("rodando",true);
				
				estaVolteando = false;
				
			}else{
				animator.SetBool("rodando",false);
			}
			
		}
		
		
		
	}
	
	
	
	// Update is called once per frame
	// Comprobamos que el pergamino se ha ocultado para poder empezar a jugar.
	void Update () {
		if (pergamino){

			if (Input.GetMouseButtonDown(0)){
				if (!empezado) {
					NotificationCenter.DefaultCenter ().PostNotification (this, "ComienzoJuego",true);
					empezado = true;
				}
				if (corriendo) { 
					if (Input.mousePosition.x < mitadPantalla){
						if (estaEnSuelo || !saltarOtraVez){
							// Si pulsamos la mitad izquierda saltar

							rigidbody2D.velocity = new Vector2(rigidbody2D.velocity.x,impulsoSalto);
							//	rigidbody2D.AddForce(new Vector2(0,impulsoSalto));
							if (!estaEnSuelo && !saltarOtraVez){
								saltarOtraVez = true;
							}
						}
					}
					else
					{
						// Si pulsamos la mitad derecha de la pantalla el personaje rotara
						
						estaVolteando = true;
						
						
						

					}
				}else{
					
					corriendo = true;
					animator.SetFloat("velocidadX",velocidad);
					
				}
				
			}
		}// fin pergamino
	}
}