﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 
using System.Runtime.Serialization.Formatters.Binary; 
using System.IO;
using System;
public class LevelUp : MonoBehaviour {
	//Controla al personaje corriendo, la musica, en la pantalla de transicion al pasar un nivel.
	List<PersonalData> personaldata = new List<PersonalData>();
	public string nombre = "";
	public int monedas= 0 ;
	public int nivel = 1;
	public float tiempoMusica = 0f;
	// manejo de excepciones
	public bool hayerror = false;
	public string msgerror = "";
	// Use this for initialization
	void Start () {
		tiempoMusica = audio.clip.length + 3f;
	}
	
	// Update is called once per frame
	void Update () {
		nivel = CargarNiveles.generalNivel + 1;
		monedas = CargarNiveles.generalPuntuacion;
		personaldata.Add (new PersonalData(nivel,monedas));
		Salvar ();
		Invoke ("CargarSiguienteNivel", tiempoMusica);

	}
	void CargarSiguienteNivel(){
		if (nivel <= CargarNiveles.generalMaxNivel) {
			Application.LoadLevel ("Escena1");
		} else {
			Application.LoadLevel ("Creditos");
		}

	}
	void Salvar(){
		try
		{
			BinaryFormatter bf = new BinaryFormatter();
			FileStream file = File.Create (Application.persistentDataPath + "/Status.gd");
			bf.Serialize(file, personaldata);
			file.Close();
		}catch (UnauthorizedAccessException e){
			hayerror = true;
			msgerror = "  Unauthorized Access to read files " + e.Message;
			
		}catch (Exception e){
			
			hayerror = true;
			msgerror = e.Message;
		}
		
	}
	void OnGUI() {
		if (hayerror) {
			GUI.Label (new Rect (0, 0, Screen.width, Screen.height),"Error. Aplication going be closed." + msgerror );
			Invoke("CerrarApp",4f);
		}
	}
	void CerrarApp(){
		Application.Quit ();
	}
}
